package grammar.pattern_match;

public class Example2 {
    Point p;

    void test2(Object o) {
        if (o instanceof Point p) {
            // p refers to the pattern variable
            p.setX(3);
            p.setY(4);
            System.out.println(p);
        } else {
            // p refers to the field
            p.setX(300);
            p.setY(400);
            System.out.println(p);
        }
    }

    public static void main(String[] args) {
        Example2 ex2 = new Example2();
        ex2.p = new Point(100, 200);
        ex2.test2(new Point(1, 2));
        ex2.test2(new String("hello world"));
    }
}
